Subject: Re: [PATCH net] net: nexthop: Initialize all fields in dumped nexthops

From: Petr Machata <[email-masked]>
Date: Thu, 25 Jul 2024 14:56:47 +0200

Petr Machata <[email-masked]> writes:

> Eric Dumazet <[email-masked]> writes:
>
>> On Wed, Jul 24, 2024 at 12:09 PM Petr Machata <[email-masked]> wrote:
>>>
>>>
>>> Eric Dumazet <[email-masked]> writes:
>>>
>>> > On Tue, Jul 23, 2024 at 7:41 PM Eric Dumazet <[email-masked]> wrote:
>>> >>
>>> >> On Tue, Jul 23, 2024 at 7:26 PM Eric Dumazet <[email-masked]> wrote:
>>> >> >
>>> >> > On Tue, Jul 23, 2024 at 6:50 PM Eric Dumazet <[email-masked]> wrote:
>>> >> > >
>>> >> > > On Tue, Jul 23, 2024 at 6:05 PM Petr Machata <[email-masked]> wrote:
>>> >> > > >
>>> >> > > > struct nexthop_grp contains two reserved fields that are not initialized by
>>> >> > > > nla_put_nh_group(), and carry garbage. This can be observed e.g. with
>>> >> > > > strace (edited for clarity):
>>> >> > > >
>>> >> > > >     # ip nexthop add id 1 dev lo
>>> >> > > >     # ip nexthop add id 101 group 1
>>> >> > > >     # strace -e recvmsg ip nexthop get id 101
>>> >> > > >     ...
>>> >> > > >     recvmsg(... [{nla_len=12, nla_type=NHA_GROUP},
>>> >> > > >                  [{id=1, weight=0, resvd1=0x69, resvd2=0x67}]] ...) = 52
>>> >> > > >
>>> >> > > > The fields are reserved and therefore not currently used. But as they are, they
>>> >> > > > leak kernel memory, and the fact they are not just zero complicates repurposing
>>> >> > > > of the fields for new ends. Initialize the full structure.
>>> >> > > >
>>> >> > > > Fixes: 430a049190de ("nexthop: Add support for nexthop groups")
>>> >> > > > Signed-off-by: Petr Machata <[email-masked]>
>>> >> > > > Reviewed-by: Ido Schimmel <[email-masked]>
>>> >> > >
>>> >> > > Interesting... not sure why syzbot did not catch this one.
>>>
>>> Could it? I'm not sure of the exact syzcaller capabilities, but there
>>> are no warnings, no splats etc. It just returns values.
>>
>> Yes, KMSAN can detect such things (uninit-value)
>
> But that would involve a splat. There's no splat with this issue, even
> though I'm testing on a CONFIG_HAVE_ARCH_KMSAN kernel.

OK, Ido tells me this is just the "it's available on this arch" option
and the actual option apparently needs clang. So disregard what I said.